/// @cond EO_CXX_EO_IMPL

inline void elm::naviframe_item::pop_to() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_naviframe_item_pop_to());
}

inline bool elm::naviframe_item::title_enabled_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_item_title_enabled_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::naviframe_item::title_enabled_set(bool enable_, bool transition_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_naviframe_item_title_enabled_set(::efl::eolian::to_c(enable_), ::efl::eolian::to_c(transition_)));
}

inline void elm::naviframe_item::promote() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_naviframe_item_promote());
}

inline void elm::naviframe_item::pop_cb_set(Elm_Naviframe_Item_Pop_Cb func_, void * data_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_naviframe_item_pop_cb_set(func_, data_));
}

inline ::efl::eina::optional< ::efl::eina::string_view > elm::naviframe_item::style_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_item_style_get());
   return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::naviframe_item::style_set(::efl::eina::optional< ::efl::eina::string_view > style_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_naviframe_item_style_set(::efl::eolian::to_c(style_)));
}

inline void eo_cxx::elm::naviframe_item::pop_to() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_naviframe_item_pop_to());
}

inline bool eo_cxx::elm::naviframe_item::title_enabled_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_item_title_enabled_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::naviframe_item::title_enabled_set(bool enable_, bool transition_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_naviframe_item_title_enabled_set(::efl::eolian::to_c(enable_), ::efl::eolian::to_c(transition_)));
}

inline void eo_cxx::elm::naviframe_item::promote() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_naviframe_item_promote());
}

inline void eo_cxx::elm::naviframe_item::pop_cb_set(Elm_Naviframe_Item_Pop_Cb func_, void * data_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_naviframe_item_pop_cb_set(func_, data_));
}

inline ::efl::eina::optional< ::efl::eina::string_view > eo_cxx::elm::naviframe_item::style_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_item_style_get());
   return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::naviframe_item::style_set(::efl::eina::optional< ::efl::eina::string_view > style_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_naviframe_item_style_set(::efl::eolian::to_c(style_)));
}

inline ::eo_cxx::elm::naviframe_item::operator ::elm::naviframe_item() const
{
   return *static_cast<::elm::naviframe_item const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::naviframe_item::operator ::elm::naviframe_item&()
{
   return *static_cast<::elm::naviframe_item*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::naviframe_item::operator ::elm::naviframe_item const&() const
{
   return *static_cast<::elm::naviframe_item const*>(static_cast<void const*>(this));
}

template <typename T>
void elm_naviframe_item_pop_to_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->pop_to();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_naviframe_item_title_enabled_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->title_enabled_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_naviframe_item_title_enabled_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool enable_, Eina_Bool transition_)
{
   try
      {
         static_cast<T*>(self->this_)->title_enabled_set(::efl::eolian::to_cxx<bool>(enable_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<bool>(transition_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_naviframe_item_promote_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->promote();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_naviframe_item_pop_cb_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Naviframe_Item_Pop_Cb func_, void * data_)
{
   try
      {
         static_cast<T*>(self->this_)->pop_cb_set(func_, data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::efl::eina::optional< ::efl::eina::string_view > elm_naviframe_item_style_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->style_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const char * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_naviframe_item_style_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * style_)
{
   try
      {
         static_cast<T*>(self->this_)->style_set(::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(style_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::naviframe_item >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::widget_item >::template type<T>
   {
      virtual void pop_to()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_naviframe_item_pop_to());
      }

      virtual bool title_enabled_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_naviframe_item_title_enabled_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void title_enabled_set(bool enable_, bool transition_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_naviframe_item_title_enabled_set(::efl::eolian::to_c(enable_), ::efl::eolian::to_c(transition_)));
      }

      virtual void promote()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_naviframe_item_promote());
      }

      virtual void pop_cb_set(Elm_Naviframe_Item_Pop_Cb func_, void * data_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_naviframe_item_pop_cb_set(func_, data_));
      }

      virtual ::efl::eina::optional< ::efl::eina::string_view > style_get()
      {
         const char * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_naviframe_item_style_get());
            return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void style_set(::efl::eina::optional< ::efl::eina::string_view > style_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_naviframe_item_style_set(::efl::eolian::to_c(style_)));
      }

   };
};


template<>
struct operation_description_class_size< ::elm::naviframe_item >
{
   static constexpr int value = 
#if defined(NAVIFRAME_ITEM_PROTECTED) && defined(NAVIFRAME_ITEM_BETA)
      7
#elif defined(NAVIFRAME_ITEM_PROTECTED)
      7
#elif defined(NAVIFRAME_ITEM_BETA)
      7
#else
      7
#endif
      + operation_description_class_size<::elm::widget_item >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::naviframe_item>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_naviframe_item_pop_to_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_naviframe_item_pop_to);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_naviframe_item_title_enabled_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_naviframe_item_title_enabled_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_naviframe_item_title_enabled_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_naviframe_item_title_enabled_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_naviframe_item_promote_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_naviframe_item_promote);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_naviframe_item_pop_cb_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_naviframe_item_pop_cb_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_naviframe_item_style_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_naviframe_item_style_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_naviframe_item_style_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_naviframe_item_style_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::widget_item>(), &ops[operation_description_class_size< ::elm::naviframe_item >::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::naviframe_item>)
{
   return (ELM_NAVIFRAME_ITEM_CLASS);
}

} } }

/// @endcond

